Index: /pkpgcounter/trunk/pkpgpdls/tiff.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/tiff.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/tiff.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/bj.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/bj.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/bj.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/pdlparser.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/pdlparser.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/pdlparser.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/ooo.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/ooo.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/ooo.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/lidil.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/lidil.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/lidil.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/inkcoverage.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/inkcoverage.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/inkcoverage.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/escpages03.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/escpages03.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/escpages03.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/__init__.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/__init__.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/__init__.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/zjstream.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/zjstream.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/zjstream.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/qpdl.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/qpdl.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/qpdl.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/plain.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/plain.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/plain.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/pnmascii.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/pnmascii.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/pnmascii.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/pdf.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/pdf.py (revision 3386)
+++ /pkpgcounter/trunk/pkpgpdls/pdf.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/hbp.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/hbp.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/hbp.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/pcl345.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/pcl345.py (revision 3400)
+++ /pkpgcounter/trunk/pkpgpdls/pcl345.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/postscript.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/postscript.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/postscript.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/escp2.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/escp2.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/escp2.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/spl1.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/spl1.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/spl1.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/cfax.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/cfax.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/cfax.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/dvi.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/dvi.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/dvi.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/pil.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/pil.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/pil.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/mscrap.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/mscrap.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/mscrap.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/analyzer.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/analyzer.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/analyzer.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/pjl.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/pjl.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/pjl.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
Index: /pkpgcounter/trunk/pkpgpdls/version.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/version.py (revision 564)
+++ /pkpgcounter/trunk/pkpgpdls/version.py (revision 3410)
@@ -1,3 +1,3 @@
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser