Index: pykota/trunk/bin/edpykota
===================================================================
--- pykota/trunk/bin/edpykota (revision 3295)
+++ pykota/trunk/bin/edpykota (revision 3411)
@@ -1,4 +1,4 @@
 #! /usr/bin/env python
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-*-
 #
 # PyKota : Print Quotas for CUPS
Index: pykota/trunk/bin/pkinvoice
===================================================================
--- pykota/trunk/bin/pkinvoice (revision 3367)
+++ pykota/trunk/bin/pkinvoice (revision 3411)
@@ -1,4 +1,4 @@
 #! /usr/bin/env python
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-*-
 #
 # PyKota : Print Quotas for CUPS
Index: pykota/trunk/bin/pykotme
===================================================================
--- pykota/trunk/bin/pykotme (revision 3360)
+++ pykota/trunk/bin/pykotme (revision 3411)
@@ -1,4 +1,4 @@
 #! /usr/bin/env python
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-*-
 #
 # PyKota : Print Quotas for CUPS
Index: pykota/trunk/bin/pkbcodes
===================================================================
--- pykota/trunk/bin/pkbcodes (revision 3367)
+++ pykota/trunk/bin/pkbcodes (revision 3411)
@@ -1,4 +1,4 @@
 #! /usr/bin/env python
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-*-
 #
 # PyKota : Print Quotas for CUPS
Index: pykota/trunk/bin/pksetup
===================================================================
--- pykota/trunk/bin/pksetup (revision 3404)
+++ pykota/trunk/bin/pksetup (revision 3411)
@@ -1,4 +1,4 @@
 #! /usr/bin/env python
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-*-
 #
 # PyKota : Print Quotas for CUPS
Index: pykota/trunk/bin/pkusers
===================================================================
--- pykota/trunk/bin/pkusers (revision 3295)
+++ pykota/trunk/bin/pkusers (revision 3411)
@@ -1,4 +1,4 @@
 #! /usr/bin/env python
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-*-
 #
 # PyKota : Print Quotas for CUPS
Index: pykota/trunk/bin/pkturnkey
===================================================================
--- pykota/trunk/bin/pkturnkey (revision 3367)
+++ pykota/trunk/bin/pkturnkey (revision 3411)
@@ -1,4 +1,4 @@
 #! /usr/bin/env python
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-*-
 #
 # PyKota : Print Quotas for CUPS
Index: pykota/trunk/bin/repykota
===================================================================
--- pykota/trunk/bin/repykota (revision 3360)
+++ pykota/trunk/bin/repykota (revision 3411)
@@ -1,4 +1,4 @@
 #! /usr/bin/env python
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-*-
 #
 # PyKota : Print Quotas for CUPS
Index: pykota/trunk/bin/warnpykota
===================================================================
--- pykota/trunk/bin/warnpykota (revision 3356)
+++ pykota/trunk/bin/warnpykota (revision 3411)
@@ -1,4 +1,4 @@
 #! /usr/bin/env python
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-*-
 #
 # PyKota : Print Quotas for CUPS
Index: pykota/trunk/bin/pkbanner
===================================================================
--- pykota/trunk/bin/pkbanner (revision 3360)
+++ pykota/trunk/bin/pkbanner (revision 3411)
@@ -1,4 +1,4 @@
 #! /usr/bin/env python
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-*-
 #
 # PyKota : Print Quotas for CUPS
Index: pykota/trunk/bin/autopykota
===================================================================
--- pykota/trunk/bin/autopykota (revision 3360)
+++ pykota/trunk/bin/autopykota (revision 3411)
@@ -1,4 +1,4 @@
 #! /usr/bin/env python
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-*-
 #
 # PyKota : Print Quotas for CUPS
Index: pykota/trunk/bin/pkprinters
===================================================================
--- pykota/trunk/bin/pkprinters (revision 3367)
+++ pykota/trunk/bin/pkprinters (revision 3411)
@@ -1,4 +1,4 @@
 #! /usr/bin/env python
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-*-
 #
 # PyKota : Print Quotas for CUPS
Index: pykota/trunk/bin/cupspykota
===================================================================
--- pykota/trunk/bin/cupspykota (revision 3334)
+++ pykota/trunk/bin/cupspykota (revision 3411)
@@ -1,4 +1,4 @@
 #! /usr/bin/env python
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-*-
 #
 # PyKota : Print Quotas for CUPS
Index: pykota/trunk/bin/pknotify
===================================================================
--- pykota/trunk/bin/pknotify (revision 3324)
+++ pykota/trunk/bin/pknotify (revision 3411)
@@ -1,4 +1,4 @@
 #! /usr/bin/env python
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-*-
 #
 # PyKota : Print Quotas for CUPS
Index: pykota/trunk/bin/pykosd
===================================================================
--- pykota/trunk/bin/pykosd (revision 3360)
+++ pykota/trunk/bin/pykosd (revision 3411)
@@ -1,4 +1,4 @@
 #! /usr/bin/env python
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-*-
 #
 # PyKota : Print Quotas for CUPS
Index: pykota/trunk/bin/dumpykota
===================================================================
--- pykota/trunk/bin/dumpykota (revision 3368)
+++ pykota/trunk/bin/dumpykota (revision 3411)
@@ -1,4 +1,4 @@
 #! /usr/bin/env python
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-*-
 #
 # PyKota : Print Quotas for CUPS
Index: pykota/trunk/bin/pkrefund
===================================================================
--- pykota/trunk/bin/pkrefund (revision 3367)
+++ pykota/trunk/bin/pkrefund (revision 3411)
@@ -1,4 +1,4 @@
 #! /usr/bin/env python
-# -*- coding: UTF-8 -*-
+# -*- coding: utf-8 -*-*-
 #
 # PyKota : Print Quotas for CUPS